#ifndef BOTPROPERTIES_H
#define BOTPROPERTIES_H

//(*Headers(BotProperties)
#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/button.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
//*)

#include "struct.h"

class BotProperties: public wxDialog
{
	public:

		BotProperties(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~BotProperties();
		void SetLabels(Bot& bot);

		enum {
			ShowNothing,
			ShowDNA,
			ShowMem
		} state;

		//(*Declarations(BotProperties)
		wxStaticText* BotMass;
		wxStaticText* BotKills;
		wxStaticText* BotNrg;
		wxStaticText* BotVel;
		wxStaticText* BotBody;
		wxStaticText* BotVenom;
		wxStaticText* BotPoison;
		wxStaticText* BotAge;
		wxTextCtrl* View;
		wxStaticText* BotSlime;
		wxStaticText* BotShell;
		wxStaticText* BotName;
		wxButton* CloseDisplay;
		wxFlexGridSizer* ViewSizer;
		//*)

	protected:

		//(*Identifiers(BotProperties)
		static const long ID_BotName;
		static const long ID_STATICTEXT2;
		static const long ID_BotAge;
		static const long ID_STATICTEXT4;
		static const long ID_BotNrg;
		static const long ID_STATICTEXT6;
		static const long ID_BotBody;
		static const long ID_STATICTEXT8;
		static const long ID_BotPoison;
		static const long ID_STATICTEXT10;
		static const long ID_BotVenom;
		static const long ID_STATICTEXT12;
		static const long ID_BotShell;
		static const long ID_STATICTEXT3;
		static const long ID_BotSlime;
		static const long ID_STATICTEXT5;
		static const long ID_BotMass;
		static const long ID_STATICTEXT9;
		static const long ID_BotVel;
		static const long ID_STATICTEXT1;
		static const long ID_BotKills;
		static const long ID_BotRepro;
		static const long ID_BotKill;
		static const long ID_BotDNA;
		static const long ID_BotMem;
		static const long ID_View;
		static const long ID_CloseDisplay;
		//*)

	private:

		//(*Handlers(BotProperties)
		void OnInit(wxInitDialogEvent& event);
		void ButtonShowDNA(wxCommandEvent& event);
		void ButtonShowMemory(wxCommandEvent& event);
		void ButtonShowNothing(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
