#ifndef NEWDIALOG_H
#define NEWDIALOG_H

//(*Headers(NewDialog)
#include <wx/checkbox.h>
#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/listctrl.h>
#include <wx/notebook.h>
#include <wx/button.h>
#include <wx/radiobut.h>
#include <wx/panel.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
//*)

#include "struct.h"
#include "TextCtrl.h"

class NewDialog: public wxDialog
{
	public:

		NewDialog(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~NewDialog();

		std::vector<BotTemplate> botlist;
		//(*Declarations(NewDialog)
		wxFloatTextCtrl* Density;
		wxButton* Color;
		wxFloatTextCtrl* Friction;
		wxFloatTextCtrl* MovCost;
		wxCheckBox* NoExec;
		wxIntTextCtrl* StartBody;
		wxCheckBox* Fixed;
		wxCheckBox* NoVis;
		wxFloatTextCtrl* ShellCost;
		wxFloatTextCtrl* AgeCost;
		wxFloatTextCtrl* VenomCost;
		wxIntTextCtrl* MaxVeg;
		wxButton* DelBot;
		wxIntTextCtrl* VegNrg;
		wxFloatTextCtrl* ShotCost;
		wxFloatTextCtrl* BodyUpkeepCost;
		wxRadioButton* NrgPerCycle;
		wxRadioButton* NrgPerKilobody;
		wxIntTextCtrl* VegRepopAmount;
		wxIntTextCtrl* FieldWidth;
		wxFloatTextCtrl* SlimeCost;
		wxFloatTextCtrl* StoreCost;
		wxIntTextCtrl* VegRepopCooldown;
		wxIntTextCtrl* FieldHeight;
		wxFloatTextCtrl* MoveEff;
		wxListCtrl* Bots;
		wxFloatTextCtrl* PoisonCost;
		wxIntTextCtrl* MaxNonVeg;
		wxFloatTextCtrl* Elast;
		wxIntTextCtrl* NumBots;
		wxIntTextCtrl* MaxVel;
		wxIntTextCtrl* VegRepopThreshold;
		wxCheckBox* Veggy;
		wxIntTextCtrl* StartNrg;
		wxTextCtrl* Comment;
		//*)

		void SetFromSettings(const SimSettings &prefs);
		void SaveToSettings(SimSettings &prefs) const;

//	protected:

		//(*Identifiers(NewDialog)
		static const long ID_Bots;
		static const long ID_AddBot;
		static const long ID_DelBot;
		static const long ID_DelAll;
		static const long ID_Comment;
		static const long ID_Color;
		static const long ID_STATICTEXT1;
		static const long ID_NumBots;
		static const long ID_STATICTEXT2;
		static const long ID_StartNrg;
		static const long ID_STATICTEXT3;
		static const long ID_StartBody;
		static const long ID_Veggy;
		static const long ID_Fixed;
		static const long ID_NoVis;
		static const long ID_NoExec;
		static const long ID_PANEL1;
		static const long ID_STATICTEXT4;
		static const long ID_FieldWidth;
		static const long ID_STATICTEXT5;
		static const long ID_FieldHeight;
		static const long ID_STATICTEXT6;
		static const long ID_MaxNonVeg;
		static const long ID_STATICTEXT7;
		static const long ID_MaxVeg;
		static const long ID_STATICTEXT8;
		static const long ID_VegRepopThreshold;
		static const long ID_STATICTEXT9;
		static const long ID_VegRepopAmount;
		static const long ID_STATICTEXT25;
		static const long ID_VegRepopCooldown;
		static const long ID_VegNrg;
		static const long ID_STATICTEXT10;
		static const long ID_NrgPerCycle;
		static const long ID_NrgPerKilobody;
		static const long ID_PANEL2;
		static const long ID_STATICTEXT11;
		static const long ID_Friction;
		static const long ID_STATICTEXT12;
		static const long ID_Density;
		static const long ID_STATICTEXT13;
		static const long ID_Elast;
		static const long ID_STATICTEXT23;
		static const long ID_MoveEff;
		static const long ID_STATICTEXT24;
		static const long ID_MaxVel;
		static const long ID_PANEL3;
		static const long ID_STATICTEXT14;
		static const long ID_StoreCost;
		static const long ID_STATICTEXT15;
		static const long ID_MovCost;
		static const long ID_STATICTEXT16;
		static const long ID_AgeCost;
		static const long ID_STATICTEXT17;
		static const long ID_ShotCost;
		static const long ID_STATICTEXT18;
		static const long ID_BodyUpkeepCost;
		static const long ID_STATICTEXT19;
		static const long ID_PoisonCost;
		static const long ID_STATICTEXT20;
		static const long ID_VenomCost;
		static const long ID_STATICTEXT21;
		static const long ID_SlimeCost;
		static const long ID_STATICTEXT22;
		static const long ID_ShellCost;
		static const long ID_PANEL4;
		static const long ID_NOTEBOOK1;
		//*)

	private:

		//(*Handlers(NewDialog)
		void OnButton2Click(wxCommandEvent& event);
		void OnInit(wxInitDialogEvent& event);
		void OnNotebook1PageChanged(wxNotebookEvent& event);
		void OnListCtrl1BeginDrag(wxListEvent& event);
		void OnListCtrl1ItemSelect(wxListEvent& event);
		void OnListCtrl1ItemDeselect(wxListEvent& event);
		void OnBotSettingChange2(wxCommandEvent& event);
		void RemoveBot(wxCommandEvent& event);
		void RemoveAllBots(wxCommandEvent& event);
		void OnTextCtrl15Text(wxCommandEvent& event);
		void SetBotColor(wxCommandEvent& event);
		//*)

		void SetSettings();
		void DisableBotFields();

		DECLARE_EVENT_TABLE()
};

#endif
