#include "TextCtrl.h"

#include "wx/textctrl.h"

#include <algorithm>

BEGIN_EVENT_TABLE(wxFloatTextCtrl, wxTextCtrl)
	EVT_KEY_DOWN(wxFloatTextCtrl::OnChar)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(wxIntTextCtrl, wxTextCtrl)
	EVT_KEY_DOWN(wxIntTextCtrl::OnChar)
END_EVENT_TABLE()

void wxFloatTextCtrl::OnChar(wxKeyEvent& event) {
	const int ch = event.GetKeyCode();
	long from, to;
	GetSelection(&from, &to);
	const wxString& value = GetValue();
	const wxString& selection = GetStringSelection();
	if (isdigit(ch) ||
			(ch == '.' &&
			std::count(value.begin(), value.end(), _T('.'))-std::count(selection.begin(), selection.end(), _T('.')) < 1) ||
			(ch == '-' &&
			std::count(value.begin(), value.end(), _T('-'))-std::count(selection.begin(), selection.end(), _T('-')) < 1 &&
			from == 0) ||
			ch == WXK_BACK ||
			ch == WXK_DELETE ||
			ch == WXK_LEFT ||
			ch == WXK_RIGHT ||
			ch == WXK_SHIFT) {
		event.Skip();
	} else {
		wxBell();
	}
}

wxFloatTextCtrl::wxFloatTextCtrl(wxWindow* parent, wxWindowID id, const wxString& value = _T(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr) {
	Create(parent, id, value, pos, size, style, validator, name);
}

void wxIntTextCtrl::OnChar(wxKeyEvent& event) {
	const int ch = event.GetKeyCode();
	if (isdigit(ch) || ch == WXK_BACK || ch == WXK_DELETE || ch == WXK_LEFT || ch == WXK_RIGHT || ch == WXK_SHIFT ) {
		event.Skip();
	} else {
		wxBell();
	}
}

wxIntTextCtrl::wxIntTextCtrl(wxWindow* parent, wxWindowID id, const wxString& value = _T(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr) {
	Create(parent, id, value, pos, size, style, validator, name);
}
