#include <wx/bitmap.h>
#include <vector>

class wxEvtHandler;
class wxDC;

// class for drawing a simple toolbar
class ToolDrawer {
	std::vector<wxBitmap> images;
	std::vector<wxBitmap> greyimages;
	std::vector<wxBitmap> lightimages;
	std::vector<int> eventids;
	std::vector<bool> issep;
	int activated;
public:
	ToolDrawer() : activated(-1) { }
	void CreateGrey();
	void Brighten(unsigned char&);
	void CreateLight();
	void AddItem(wxBitmap, int eventid);
	void AddSeparator();
	int HitTest(int x, int y) const;
	bool DoActivate(int x, int y);
	void DeActivate() { activated = -1; }
	bool DoHit(wxEvtHandler& handler, int x, int y, const bool disabled[]) const;
	void Draw(wxDC& dc, int x, const bool activate[], const bool disabled[]) const;
};
