#include <string>

struct op {
	const std::string name;
	const int num, int_in, int_out, bool_in, bool_out;
};


const op ops[] = {
#define o_inc 1
{ "inc", 1, 1, 0, 0, 0 },
#define o_dec 2
{ "dec", 2, 1, 0, 0, 0 },
#define o_add 3
{ "add", 3, 2, 1, 0, 0 },
#define o_sub 4
{ "sub", 4, 2, 1, 0, 0 },
#define o_mult 5
{ "mult", 5, 2, 1, 0, 0 },
#define o_div 6
{ "div", 6, 2, 1, 0, 0 },
#define o_store 7
{ "store", 7, 2, 0, 0, 0 },
#define o_read 8
{ "*", 8, 1, 1, 0, 0 },
#define o_start 9
{ "start", 9, 0, 0, 0, 0 },
#define o_stop 10
{ "stop", 10, 0, 0, 0, 0 },
#define o_pyth 11
{ "pyth", 11, 2, 1, 0, 0 },
#define o_sqr 12
{ "sqr", 12, 1, 1, 0, 0 },
#define o_c_lt 13
{ "<", 13, 2, 0, 0, 1 },
#define o_c_gt 14
{ ">", 14, 2, 0, 0, 1 },
#define o_c_eq 15
{ "=", 15, 2, 0, 0, 1 },
#define o_c_le 16
{ "<=", 16, 2, 0, 0, 1 },
#define o_c_ge 17
{ ">=", 17, 2, 0, 0, 1 },
#define o_c_ne 18
{ "!=", 18, 2, 0, 0, 1 },
#define o_c_true 19
{ "true", 19, 0, 0, 0, 1 },
#define o_c_false 20
{ "false", 20, 0, 0, 0, 1 },
#define o_c_and 21
{ "and", 21, 0, 0, 2, 1 },
#define o_c_or 22
{ "or", 22, 0, 0, 2, 1 },
#define o_c_xor 23
{ "xor", 23, 0, 0, 2, 1 },
#define o_c_not 24
{ "not", 24, 0, 0, 1, 1 },
#define o_cond 25
{ "cond", 25, 0, 0, 0, 0 },
#define o_dist 26
{ "dist", 26, 2, 1, 0, 0 },
#define o_angle 27
{ "angle", 27, 2, 1, 0, 0 },
#define o_mod 28
{ "mod", 28, 2, 1, 0, 0 },
#define o_rnd 29
{ "rnd", 29, 1, 1, 0, 0 },
#define o_abs 30
{ "abs", 30, 1, 1, 0, 0 },
#define o_dup 31
{ "dup", 31, 1, 2, 0, 0 },
//#define o_dupint 31
{ "dupint", 31, 1, 2, 0, 0 },
#define o_dupbool 32
{ "dupbool", 32, 0, 0, 1, 2 },
#define o_swap 33
{ "swap", 33, 2, 2, 0, 0 },
//#define o_swapint 33
{ "swapint", 33, 2, 2, 0, 0 },
#define o_swapbool 34
{ "swapbool", 34, 0, 0, 2, 2 },
#define o_dropbool 35
{ "dropbool", 35, 0, 0, 1, 0 },
#define o_clearbool 36
{ "clearbool", 36, 0, 0, -1, 0 },
#define o_xorint 37
{ "^", 37, 2, 1, 0, 0 },
#define o_shr 38
{ ">>", 38, 2, 1, 0, 0 },
#define o_shl 39
{ "<<", 39, 2, 1, 0, 0 },
#define o_andint 40
{ "&", 40, 2, 1, 0, 0 },
#define o_orint 41
{ "|", 41, 2, 1, 0, 0 },
#define o_incint 42
{ "++", 42, 1, 1, 0, 0 },
#define o_decint 43
{ "--", 43, 1, 1, 0, 0 },
#define o_neg 44
{ "-", 44, 1, 1, 0, 0 },
#define o_sgn 45
{ "sgn", 45, 1, 1, 0, 0 },
#define o_pow 46
{ "pow", 46, 2, 1, 0, 0 }
};

const int num_ops = 46;
