#ifndef WXBOTS_H
#define WXBOTS_H

#include "wx/wxprec.h"

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "struct.h"

class wxBotView: public wxWindow {
public:
	wxBotView() {}
	wxBotView(wxWindow* parent) : wxWindow(parent, wxID_ANY, wxDefaultPosition, wxDefaultSize,
		wxFULL_REPAINT_ON_RESIZE | wxBORDER_THEME), viewx(0), viewy(0), pressed_item(-1), mx(-1), my(-1), zoom(1.0f),
		img_backing(NULL), bmp_backing(NULL) { }
	virtual void OnPaint(wxPaintEvent& event);
	void OnDown(wxMouseEvent& event);
	void OnUp(wxMouseEvent& event);
	void OnDClick(wxMouseEvent& event);
	void OnRUp(wxMouseEvent& event);
	void OnMove(wxMouseEvent& event);
	void OnWheel(wxMouseEvent& event);
	void MouseCaptureLost(wxMouseCaptureLostEvent&);
	void Zoom(bool in, float amt);
	int viewx, viewy, pressed_item, mx, my;
	float zoom;
	wxImage* img_backing;
	wxBitmap* bmp_backing;
private:
	DECLARE_EVENT_TABLE()
};

class MainFrame: public wxFrame {
public:
	MainFrame(const wxString& title, const wxPoint& pos, const wxSize& size);
	void OnEvent(wxCommandEvent& event);
	void OnClose(wxCloseEvent& event);
	void OnIdle(wxIdleEvent& event);
	void SaveSim(int compress = 6);
	bool pause, nodisp, saving_or_loading;
private:
	wxStopWatch stopwatch;
	unsigned long cycles_s;
	wxBotView* botview;
	wxStatusBar* statusbar;
	DECLARE_EVENT_TABLE()
};

class App: public wxApp {
public:
	virtual bool OnInit();
	MainFrame* window;
};

enum {
	ID_New = wxID_NEW,
	ID_Load = wxID_OPEN,
	ID_Save = wxID_SAVE,
	ID_Options = wxID_PREFERENCES,
	ID_Quit = wxID_EXIT,
	ID_About = wxID_ABOUT,
	ID_ZoomIn = wxID_ZOOM_IN,
	ID_ZoomOut = wxID_ZOOM_OUT,
	ID_ZoomNone = wxID_ZOOM_100,
	ID_Reset = 1,
	ID_Play,
	ID_Pause,
	ID_Cycle,
	ID_NoDisplay
};

#endif
